// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/core/v8/v8_css_toggle_data.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_string_unsignedlong.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_union_stringsequence_unsignedlong.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



CSSToggleData* CSSToggleData::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  CSSToggleData* dictionary = MakeGarbageCollected<CSSToggleData>(isolate);
if (v8_value->IsNullOrUndefined()) {
  return dictionary;
}
if (!v8_value->IsObject()) {
  const char* const class_like_name = "CSSToggleData";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 CSSToggleData::CSSToggleData() : member_states_(MakeGarbageCollected<V8UnionStringSequenceOrUnsignedLong>(1)), member_value_(MakeGarbageCollected<V8UnionStringOrUnsignedLong>(0)) {
  
}

 CSSToggleData::CSSToggleData(v8::Isolate* isolate) : member_states_(MakeGarbageCollected<V8UnionStringSequenceOrUnsignedLong>(1)), member_value_(MakeGarbageCollected<V8UnionStringOrUnsignedLong>(0)) {
  
}




























void CSSToggleData::Trace(Visitor* visitor) const {
  TraceIfNeeded<V8CSSToggleCycle>::Trace(visitor, member_cycle_);
TraceIfNeeded<bool>::Trace(visitor, member_group_);
TraceIfNeeded<V8CSSToggleScope>::Trace(visitor, member_scope_);
TraceIfNeeded<Member<V8UnionStringSequenceOrUnsignedLong>>::Trace(visitor, member_states_);
TraceIfNeeded<Member<V8UnionStringOrUnsignedLong>>::Trace(visitor, member_value_);
bindings::DictionaryBase::Trace(visitor);
}

bool CSSToggleData::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool was_property_created;
if (hasCycle()) {
  if (!ToV8Traits<V8CSSToggleCycle>::ToV8(script_state, member_cycle_).ToLocal(&v8_value)) {
  return false;
}
if (!v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).To(&was_property_created)) {
  return false;
}
}
if (hasGroup()) {
  if (!ToV8Traits<IDLBoolean>::ToV8(script_state, member_group_).ToLocal(&v8_value)) {
  return false;
}
if (!v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).To(&was_property_created)) {
  return false;
}
}
if (hasScope()) {
  if (!ToV8Traits<V8CSSToggleScope>::ToV8(script_state, member_scope_).ToLocal(&v8_value)) {
  return false;
}
if (!v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).To(&was_property_created)) {
  return false;
}
}
if (hasStates()) {
  if (!ToV8Traits<V8UnionStringSequenceOrUnsignedLong>::ToV8(script_state, member_states_).ToLocal(&v8_value)) {
  return false;
}
if (!v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).To(&was_property_created)) {
  return false;
}
}
if (hasValue()) {
  if (!ToV8Traits<V8UnionStringOrUnsignedLong>::ToV8(script_state, member_value_).ToLocal(&v8_value)) {
  return false;
}
if (!v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).To(&was_property_created)) {
  return false;
}
}
return true;
}

void CSSToggleData::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "CSSToggleData";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContext::Context::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("cycle");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool fallback_presence_var;
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<V8CSSToggleCycle, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), fallback_presence_var, member_cycle_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("group");
if (!bindings::GetDictionaryMemberFromV8Object<IDLBoolean, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_group_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("scope");
if (!bindings::GetDictionaryMemberFromV8Object<V8CSSToggleScope, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_scope_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("states");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionStringSequenceOrUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_states_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("value");
if (!bindings::GetDictionaryMemberFromV8Object<V8UnionStringOrUnsignedLong, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), fallback_presence_var, member_value_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> CSSToggleData::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"cycle",
"group",
"scope",
"states",
"value",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
