// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_CSS_TOGGLE_DATA_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_CSS_TOGGLE_DATA_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_css_toggle_cycle.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_css_toggle_scope.h"
#include "third_party/blink/renderer/core/core_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class V8UnionStringOrUnsignedLong;
class V8UnionStringSequenceOrUnsignedLong;

class CORE_EXPORT CSSToggleData : public bindings::DictionaryBase {
  
  public:
static CSSToggleData* Create() {
  return MakeGarbageCollected<CSSToggleData>();
}
static CSSToggleData* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<CSSToggleData>(isolate);
}
static CSSToggleData* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  CSSToggleData();
explicit  CSSToggleData(v8::Isolate* isolate);

bool hasCycle() const {
  return true;
}
V8CSSToggleCycle cycle() const {
  return member_cycle_;
}
void setCycle(V8CSSToggleCycle value) {
  member_cycle_ = value;
}
void setCycle(V8CSSToggleCycle::Enum value) {
  member_cycle_ = V8CSSToggleCycle(value);
}

bool hasGroup() const {
  return true;
}
bool group() const {
  return member_group_;
}
void setGroup(bool value) {
  member_group_ = value;
}

bool hasScope() const {
  return true;
}
V8CSSToggleScope scope() const {
  return member_scope_;
}
void setScope(V8CSSToggleScope value) {
  member_scope_ = value;
}
void setScope(V8CSSToggleScope::Enum value) {
  member_scope_ = V8CSSToggleScope(value);
}

bool hasStates() const {
  return true;
}
V8UnionStringSequenceOrUnsignedLong* states() const {
  return member_states_;
}
void setStates(V8UnionStringSequenceOrUnsignedLong* value) {
  member_states_ = value;
DCHECK(member_states_);
}

bool hasValue() const {
  return true;
}
V8UnionStringOrUnsignedLong* value() const {
  return member_value_;
}
void setValue(V8UnionStringOrUnsignedLong* value) {
  member_value_ = value;
DCHECK(member_value_);
}


// Obsolete accessor functions
void setCycle(const String& value) {
  member_cycle_ = V8CSSToggleCycle::Create(value).value();
}
void setScope(const String& value) {
  member_scope_ = V8CSSToggleScope::Create(value).value();
}

void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);



V8CSSToggleCycle member_cycle_{V8CSSToggleCycle::Enum::kCycle};
bool member_group_{false};
V8CSSToggleScope member_scope_{V8CSSToggleScope::Enum::kWide};
Member<V8UnionStringSequenceOrUnsignedLong> member_states_;
Member<V8UnionStringOrUnsignedLong> member_value_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_CORE_V8_V8_CSS_TOGGLE_DATA_H_
