// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#include "third_party/blink/renderer/bindings/modules/v8/v8_m_doc_provider.h"

#include "third_party/blink/renderer/bindings/core/v8/generated_code_helper.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/to_v8_traits.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_m_doc_element.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_m_doc_storage_duration.h"
#include "third_party/blink/renderer/platform/bindings/exception_messages.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/bindings/v8_per_isolate_data.h"

namespace blink {



MDocProvider* MDocProvider::Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state) {
  MDocProvider* dictionary = MakeGarbageCollected<MDocProvider>(isolate);
if (!v8_value->IsObject()) {
  const char* const class_like_name = "MDocProvider";
exception_state.ThrowTypeError(ExceptionMessages::ValueNotOfType(class_like_name));
return nullptr;
}
dictionary->FillMembersFromV8Object(isolate, v8_value.As<v8::Object>(), exception_state);
if (UNLIKELY(exception_state.HadException())) {
  return nullptr;
}
return dictionary;
}

 MDocProvider::MDocProvider() {
  
}

 MDocProvider::MDocProvider(v8::Isolate* isolate) {
  
}



Vector<String> MDocProvider::getCertificatesOr(const Vector<String>& fallback_value) const {
  if (!hasCertificates()) {
  return fallback_value;
}
return member_certificates_;
}

Vector<String> MDocProvider::getCertificatesOr(Vector<String>&& fallback_value) const {
  if (!hasCertificates()) {
  return std::move(fallback_value);
}
return member_certificates_;
}

void MDocProvider::setCertificates(const Vector<String>& value) {
  member_certificates_ = value;
has_certificates_ = true;
}

void MDocProvider::setCertificates(Vector<String>&& value) {
  member_certificates_ = std::move(value);
has_certificates_ = true;
}




void MDocProvider::setDocumentType(const String& value) {
  member_document_type_ = value;
}

void MDocProvider::setDocumentType(String&& value) {
  member_document_type_ = std::move(value);
}




void MDocProvider::setReaderPublicKey(const String& value) {
  member_reader_public_key_ = value;
}

void MDocProvider::setReaderPublicKey(String&& value) {
  member_reader_public_key_ = std::move(value);
}




void MDocProvider::setRequestedElements(const HeapVector<Member<MDocElement>>& value) {
  member_requested_elements_ = value;
}

void MDocProvider::setRequestedElements(HeapVector<Member<MDocElement>>&& value) {
  member_requested_elements_ = std::move(value);
}











void MDocProvider::Trace(Visitor* visitor) const {
  TraceIfNeeded<Vector<String>>::Trace(visitor, member_certificates_);
TraceIfNeeded<String>::Trace(visitor, member_document_type_);
TraceIfNeeded<String>::Trace(visitor, member_reader_public_key_);
TraceIfNeeded<HeapVector<Member<MDocElement>>>::Trace(visitor, member_requested_elements_);
TraceIfNeeded<Member<MDocStorageDuration>>::Trace(visitor, member_retention_);
bindings::DictionaryBase::Trace(visitor);
}

bool MDocProvider::FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const {
  v8::Local<v8::Value> v8_value;
v8::Isolate* isolate = script_state->GetIsolate();
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
bool was_property_created;
if (hasCertificates()) {
  if (!ToV8Traits<IDLSequence<IDLString>>::ToV8(script_state, member_certificates_).ToLocal(&v8_value)) {
  return false;
}
if (!v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[0].Get(isolate), v8_value).To(&was_property_created)) {
  return false;
}
}
if (hasDocumentType()) {
  if (!ToV8Traits<IDLString>::ToV8(script_state, member_document_type_).ToLocal(&v8_value)) {
  return false;
}
if (!v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[1].Get(isolate), v8_value).To(&was_property_created)) {
  return false;
}
}
if (hasReaderPublicKey()) {
  if (!ToV8Traits<IDLString>::ToV8(script_state, member_reader_public_key_).ToLocal(&v8_value)) {
  return false;
}
if (!v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[2].Get(isolate), v8_value).To(&was_property_created)) {
  return false;
}
}
if (hasRequestedElements()) {
  if (!ToV8Traits<IDLSequence<MDocElement>>::ToV8(script_state, member_requested_elements_).ToLocal(&v8_value)) {
  return false;
}
if (!v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[3].Get(isolate), v8_value).To(&was_property_created)) {
  return false;
}
}
if (hasRetention()) {
  if (!ToV8Traits<MDocStorageDuration>::ToV8(script_state, member_retention_).ToLocal(&v8_value)) {
  return false;
}
if (!v8_dictionary->CreateDataProperty(current_context, v8_own_member_names[4].Get(isolate), v8_value).To(&was_property_created)) {
  return false;
}
}
return true;
}

void MDocProvider::FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state) {
  const char* const class_like_name = "MDocProvider";
ExceptionState::ContextScope exception_context_scope(ExceptionContext(ExceptionContext::Context::kDictionaryMemberGet, class_like_name, ""), exception_state);
exception_context_scope.ChangePropertyNameAsOptimizationHack("certificates");
constexpr bool is_optional = false;
v8::Local<v8::Context> current_context = isolate->GetCurrentContext();
const auto& v8_own_member_names = GetV8OwnMemberNames(isolate);
v8::TryCatch try_block(isolate);
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<IDLString>, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[0].Get(isolate), has_certificates_, member_certificates_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("documentType");
constexpr bool is_required = true;
bool fallback_presence_var;
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[1].Get(isolate), fallback_presence_var, member_document_type_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("readerPublicKey");
if (!bindings::GetDictionaryMemberFromV8Object<IDLString, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[2].Get(isolate), fallback_presence_var, member_reader_public_key_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("requestedElements");
if (!bindings::GetDictionaryMemberFromV8Object<IDLSequence<MDocElement>, is_required>(isolate, current_context, v8_dictionary, v8_own_member_names[3].Get(isolate), fallback_presence_var, member_requested_elements_, try_block, exception_state)) {
  return;
}
exception_context_scope.ChangePropertyNameAsOptimizationHack("retention");
if (!bindings::GetDictionaryMemberFromV8Object<MDocStorageDuration, is_optional>(isolate, current_context, v8_dictionary, v8_own_member_names[4].Get(isolate), has_retention_, member_retention_, try_block, exception_state)) {
  return;
}
}

const base::span<const v8::Eternal<v8::Name>> MDocProvider::GetV8OwnMemberNames(v8::Isolate* isolate) {
  static const char* const kOwnMemberNames[] = {
"certificates",
"documentType",
"readerPublicKey",
"requestedElements",
"retention",
};
return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(kOwnMemberNames, kOwnMemberNames);
}


}  // namespace blink
