// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_M_DOC_PROVIDER_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_M_DOC_PROVIDER_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

namespace blink {

class ExceptionState;
class MDocElement;
class MDocStorageDuration;

class MODULES_EXPORT MDocProvider : public bindings::DictionaryBase {
  
  public:
static MDocProvider* Create() {
  return MakeGarbageCollected<MDocProvider>();
}
static MDocProvider* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MDocProvider>(isolate);
}
static MDocProvider* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MDocProvider();
explicit  MDocProvider(v8::Isolate* isolate);

bool hasCertificates() const {
  return has_certificates_;
}
const Vector<String>& certificates() const {
  DCHECK(hasCertificates());
return member_certificates_;
}
Vector<String> getCertificatesOr(const Vector<String>& fallback_value) const;
Vector<String> getCertificatesOr(Vector<String>&& fallback_value) const;
void setCertificates(const Vector<String>& value);
void setCertificates(Vector<String>&& value);

bool hasDocumentType() const {
  return true;
}
const String& documentType() const {
  return member_document_type_;
}
void setDocumentType(const String& value);
void setDocumentType(String&& value);

bool hasReaderPublicKey() const {
  return true;
}
const String& readerPublicKey() const {
  return member_reader_public_key_;
}
void setReaderPublicKey(const String& value);
void setReaderPublicKey(String&& value);

bool hasRequestedElements() const {
  return true;
}
const HeapVector<Member<MDocElement>>& requestedElements() const {
  return member_requested_elements_;
}
void setRequestedElements(const HeapVector<Member<MDocElement>>& value);
void setRequestedElements(HeapVector<Member<MDocElement>>&& value);

bool hasRetention() const {
  return has_retention_;
}
MDocStorageDuration* retention() const {
  DCHECK(hasRetention());
return member_retention_;
}
MDocStorageDuration* getRetentionOr(MDocStorageDuration* fallback_value) const {
  if (!hasRetention()) {
  return fallback_value;
}
return member_retention_;
}
void setRetention(MDocStorageDuration* value) {
  member_retention_ = value;
has_retention_ = true;
DCHECK(member_retention_);
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_certificates_ = false;
bool has_retention_ = false;

Vector<String> member_certificates_;
String member_document_type_;
String member_reader_public_key_;
HeapVector<Member<MDocElement>> member_requested_elements_;
Member<MDocStorageDuration> member_retention_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_M_DOC_PROVIDER_H_
