// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MEDIA_TRACK_FRAME_STATS_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MEDIA_TRACK_FRAME_STATS_H_

#include "base/containers/span.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/dictionary_base.h"

namespace blink {

class ExceptionState;

class MODULES_EXPORT MediaTrackFrameStats : public bindings::DictionaryBase {
  
  public:
static MediaTrackFrameStats* Create() {
  return MakeGarbageCollected<MediaTrackFrameStats>();
}
static MediaTrackFrameStats* Create(v8::Isolate* isolate) {
  return MakeGarbageCollected<MediaTrackFrameStats>(isolate);
}
static MediaTrackFrameStats* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  MediaTrackFrameStats();
explicit  MediaTrackFrameStats(v8::Isolate* isolate);

bool hasDeliveredFrames() const {
  return has_delivered_frames_;
}
uint64_t deliveredFrames() const {
  DCHECK(hasDeliveredFrames());
return member_delivered_frames_;
}
uint64_t getDeliveredFramesOr(uint64_t fallback_value) const {
  if (!hasDeliveredFrames()) {
  return fallback_value;
}
return member_delivered_frames_;
}
void setDeliveredFrames(uint64_t value) {
  member_delivered_frames_ = value;
has_delivered_frames_ = true;
}

bool hasDiscardedFrames() const {
  return has_discarded_frames_;
}
uint64_t discardedFrames() const {
  DCHECK(hasDiscardedFrames());
return member_discarded_frames_;
}
uint64_t getDiscardedFramesOr(uint64_t fallback_value) const {
  if (!hasDiscardedFrames()) {
  return fallback_value;
}
return member_discarded_frames_;
}
void setDiscardedFrames(uint64_t value) {
  member_discarded_frames_ = value;
has_discarded_frames_ = true;
}

bool hasTotalFrames() const {
  return has_total_frames_;
}
uint64_t totalFrames() const {
  DCHECK(hasTotalFrames());
return member_total_frames_;
}
uint64_t getTotalFramesOr(uint64_t fallback_value) const {
  if (!hasTotalFrames()) {
  return fallback_value;
}
return member_total_frames_;
}
void setTotalFrames(uint64_t value) {
  member_total_frames_ = value;
has_total_frames_ = true;
}




void Trace(Visitor* visitor) const override;


  protected:
bool FillV8ObjectWithMembers(ScriptState* script_state, v8::Local<v8::Object> v8_dictionary) const override;

void FillMembersFromV8Object(v8::Isolate* isolate, v8::Local<v8::Object> v8_dictionary, ExceptionState& exception_state);


  private:
static const base::span<const v8::Eternal<v8::Name>> GetV8OwnMemberNames(v8::Isolate* isolate);

bool has_delivered_frames_ = false;
bool has_discarded_frames_ = false;
bool has_total_frames_ = false;

uint64_t member_delivered_frames_;
uint64_t member_discarded_frames_;
uint64_t member_total_frames_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_MEDIA_TRACK_FRAME_STATS_H_
