// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_GPUCOMPUTEPASSTIMESTAMPWRITESEQUENCE_GPUCOMPUTEPASSTIMESTAMPWRITES_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_GPUCOMPUTEPASSTIMESTAMPWRITESEQUENCE_GPUCOMPUTEPASSTIMESTAMPWRITES_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class GPUComputePassTimestampWrite;
class GPUComputePassTimestampWrites;

class MODULES_EXPORT V8UnionGPUComputePassTimestampWriteSequenceOrGPUComputePassTimestampWrites final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kGPUComputePassTimestampWriteSequence, kGPUComputePassTimestampWrites
};

static V8UnionGPUComputePassTimestampWriteSequenceOrGPUComputePassTimestampWrites* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionGPUComputePassTimestampWriteSequenceOrGPUComputePassTimestampWrites(const HeapVector<Member<GPUComputePassTimestampWrite>>& value);
explicit  V8UnionGPUComputePassTimestampWriteSequenceOrGPUComputePassTimestampWrites(HeapVector<Member<GPUComputePassTimestampWrite>>&& value);
explicit  V8UnionGPUComputePassTimestampWriteSequenceOrGPUComputePassTimestampWrites(GPUComputePassTimestampWrites* value) : content_type_(ContentType::kGPUComputePassTimestampWrites), member_gpu_compute_pass_timestamp_writes_(value) {
  DCHECK(value);
}

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsGPUComputePassTimestampWriteSequence() const {
  return content_type_ == ContentType::kGPUComputePassTimestampWriteSequence;
}
const HeapVector<Member<GPUComputePassTimestampWrite>>& GetAsGPUComputePassTimestampWriteSequence() const {
  DCHECK_EQ(content_type_, ContentType::kGPUComputePassTimestampWriteSequence);
return member_gpu_compute_pass_timestamp_write_sequence_;
}
void Set(const HeapVector<Member<GPUComputePassTimestampWrite>>& value);
void Set(HeapVector<Member<GPUComputePassTimestampWrite>>&& value);

bool IsGPUComputePassTimestampWrites() const {
  return content_type_ == ContentType::kGPUComputePassTimestampWrites;
}
GPUComputePassTimestampWrites* GetAsGPUComputePassTimestampWrites() const {
  DCHECK_EQ(content_type_, ContentType::kGPUComputePassTimestampWrites);
return member_gpu_compute_pass_timestamp_writes_;
}
void Set(GPUComputePassTimestampWrites* value) {
  DCHECK(value);
Clear();
member_gpu_compute_pass_timestamp_writes_ = value;
content_type_ = ContentType::kGPUComputePassTimestampWrites;
}


v8::MaybeLocal<v8::Value> ToV8Value(ScriptState* script_state) const override;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(GPUComputePassTimestampWrites or sequence<GPUComputePassTimestampWrite>)";
}

ContentType content_type_;

HeapVector<Member<GPUComputePassTimestampWrite>> member_gpu_compute_pass_timestamp_write_sequence_;
Member<GPUComputePassTimestampWrites> member_gpu_compute_pass_timestamp_writes_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_GPUCOMPUTEPASSTIMESTAMPWRITESEQUENCE_GPUCOMPUTEPASSTIMESTAMPWRITES_H_
