// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// DO NOT EDIT: This file is auto-generated by
// //third_party/blink/renderer/bindings/scripts/generate_bindings.py
//
// Use the GN flag `blink_enable_generated_code_formatting=true` to enable
// formatting of the generated files.

#ifndef THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_GPURENDERPASSTIMESTAMPWRITESEQUENCE_GPURENDERPASSTIMESTAMPWRITES_H_
#define THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_GPURENDERPASSTIMESTAMPWRITESEQUENCE_GPURENDERPASSTIMESTAMPWRITES_H_

#include "base/check_op.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/platform/bindings/union_base.h"
#include "third_party/blink/renderer/platform/heap/collection_support/heap_vector.h"
#include "third_party/blink/renderer/platform/heap/member.h"

namespace blink {

class ExceptionState;
class GPURenderPassTimestampWrite;
class GPURenderPassTimestampWrites;

class MODULES_EXPORT V8UnionGPURenderPassTimestampWriteSequenceOrGPURenderPassTimestampWrites final : public bindings::UnionBase {
  
  public:
// The type of the content value of this IDL union.
enum class ContentType {
kGPURenderPassTimestampWriteSequence, kGPURenderPassTimestampWrites
};

static V8UnionGPURenderPassTimestampWriteSequenceOrGPURenderPassTimestampWrites* Create(v8::Isolate* isolate, v8::Local<v8::Value> v8_value, ExceptionState& exception_state);

explicit  V8UnionGPURenderPassTimestampWriteSequenceOrGPURenderPassTimestampWrites(const HeapVector<Member<GPURenderPassTimestampWrite>>& value);
explicit  V8UnionGPURenderPassTimestampWriteSequenceOrGPURenderPassTimestampWrites(HeapVector<Member<GPURenderPassTimestampWrite>>&& value);
explicit  V8UnionGPURenderPassTimestampWriteSequenceOrGPURenderPassTimestampWrites(GPURenderPassTimestampWrites* value) : content_type_(ContentType::kGPURenderPassTimestampWrites), member_gpu_render_pass_timestamp_writes_(value) {
  DCHECK(value);
}

// Returns the type of the content value.
ContentType GetContentType() const {
  return content_type_;
}

bool IsGPURenderPassTimestampWriteSequence() const {
  return content_type_ == ContentType::kGPURenderPassTimestampWriteSequence;
}
const HeapVector<Member<GPURenderPassTimestampWrite>>& GetAsGPURenderPassTimestampWriteSequence() const {
  DCHECK_EQ(content_type_, ContentType::kGPURenderPassTimestampWriteSequence);
return member_gpu_render_pass_timestamp_write_sequence_;
}
void Set(const HeapVector<Member<GPURenderPassTimestampWrite>>& value);
void Set(HeapVector<Member<GPURenderPassTimestampWrite>>&& value);

bool IsGPURenderPassTimestampWrites() const {
  return content_type_ == ContentType::kGPURenderPassTimestampWrites;
}
GPURenderPassTimestampWrites* GetAsGPURenderPassTimestampWrites() const {
  DCHECK_EQ(content_type_, ContentType::kGPURenderPassTimestampWrites);
return member_gpu_render_pass_timestamp_writes_;
}
void Set(GPURenderPassTimestampWrites* value) {
  DCHECK(value);
Clear();
member_gpu_render_pass_timestamp_writes_ = value;
content_type_ = ContentType::kGPURenderPassTimestampWrites;
}


v8::MaybeLocal<v8::Value> ToV8Value(ScriptState* script_state) const override;

void Trace(Visitor* visitor) const override;


  
  private:
void Clear();

static constexpr const char* UnionNameInIDL() {
  return "(GPURenderPassTimestampWrites or sequence<GPURenderPassTimestampWrite>)";
}

ContentType content_type_;

HeapVector<Member<GPURenderPassTimestampWrite>> member_gpu_render_pass_timestamp_write_sequence_;
Member<GPURenderPassTimestampWrites> member_gpu_render_pass_timestamp_writes_;


  
};


}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_BINDINGS_MODULES_V8_V8_UNION_GPURENDERPASSTIMESTAMPWRITESEQUENCE_GPURENDERPASSTIMESTAMPWRITES_H_
